<script type="text/javascript">

    var last_log_line   = 0;
    var initial_load    = true;
    var log_lines       = Array();
    var max_log_lines   = 20;
    var logs_refresh_timer_set = false;

    jQuery(document).ready(function($) {
        $.ajaxSetup({
            type: 'POST',
            url: ajaxurl, /* predefined WP value */
            complete: function(xhr,status) {
                if ( status != 'success' ) {
                    console.log("Failed to communicate with WP");
                    /* QtrLogMessage("ERROR", "Failed to communicate with WordPress. Status: " + status ); */
                }
            }
        });


        $('#run-internal-scanner').click( function() {
            console.log("run-internal-scan clicked");
            QtrCleanExecutionLog();
            QtrRunInternalScan( 0 );
            QtrShowEmptyThreatsReport ( );
	        QtrShowProgressBar();
            return false;
        });


        $('#clean-log').click( function() {
            QtrCleanExecutionLog();
        });



        $('#stop-internal-scanner').click( function() {
            console.log("stop_internal_scan"); 
	        QtrHideProgressBar();
            jQuery.ajax({
                data: {
                    action: 'scanner-stop_internal_scan',
                }, 
                success: function(r) {
                    QtrLogMessage("INFO", "Termination sent successfully");
                    QtrLogMessage("INFO", r );
                    console.log(r);
                }//end of success function
            });
        });

        /*
         * Hook to catch bootstrap tabs switching
         */ 
        $('a[data-toggle="tab"]').on('shown.bs.tab', function(e){
             var currentTab = $(e.target).text(); // get current tab
             var LastTab = $(e.relatedTarget).text(); // get last tab
             //alert(currentTab);
             if( currentTab.indexOf("Detected") >= 0 ){
                 console.log("Detected Threats");
                 QtrReloadDetectedThreatsReport();
             }else if( currentTab.indexOf("Summary") >= 0 ){
                 //alert("Summary");
                 QtrReloadExecutionStatus( 0 );
             }else if( currentTab.indexOf("Ignored") >= 0 ){
                 //alert("Ignored Threats");
                 QtrReloadIgnoredThreatsReport();
             }
        });


        $('#clean-ignore-list').click( function() {
            console.log("clean-ignore-list"); 
            jQuery.ajax({
                data: {
                    action: 'scanner-clean_ignore_list',
                }, 
                success: function(r) {
                    QtrLogMessage("INFO", "Ignore list cleaned successfully");
                    QtrLogMessage("INFO", r );
                    console.log(r);
                    /*
                     * refresh list of detect threat and restore all threats removed from ignore list
                     */
                    QtrReloadDetectedThreatsReport();
                    QtrReloadIgnoredThreatsReport();
                }//end of success function
            });
        });


        $('#clean-files-white-list').click( function() {
            console.log("clean-files-white-list"); 
            jQuery.ajax({
                data: {
                    action: 'scanner-clean_files_whitelist',
                }, 
                success: function(r) {
                    QtrLogMessage ("INFO", "Files whitellist cleaned successfully");
                    QtrLogMessage ("INFO", r );
                    console.log(r);
                    /*
                     * refresh list of detect threat and restore all threats removed from ignore list
                     */
                    QtrReloadDetectedThreatsReport();
                }//end of success function
            });
        });


        $('#clean-threats-white-list').click( function() {
            console.log("clean-threats-white-list"); 
            jQuery.ajax({
                data: {
                    action: 'scanner-clean_threats_whitelist',
                }, 
                success: function(r) {
                    QtrLogMessage ("INFO", "Threats whitellist cleaned successfully");
                    QtrLogMessage ("INFO", r );
                    console.log(r);
                    /*
                     * refresh list of detect threat and restore all threats removed from ignore list
                     */
                    QtrReloadDetectedThreatsReport();
                }//end of success function
            });
        });

        /*
         * Clean last log line to retrieve an entire log
         */
        last_log_line = 0;
        /*
         * retrieve log and execution statistics
         */
        QtrReloadExecutionStatus( 1 /*repeat*/ );
        /*
         * Show the hidden pane
         */
        $('#progress-pane').show();

        setInterval(QtrUpdateProgressBar,10000);
    
        /*
         * Show progress bar if scan already running
         */
        QtrIsInternalScanRunning();

    }); 

    function QtrShowProgressBar(){
	    document.getElementById("progress_bar").style.display = 'block';
    }

    function QtrHideProgressBar(){
	    document.getElementById("progress_bar").style.display = 'none';
    }

    function QtrUpdateProgressBar(){
	    QtrIsInternalScanRunning();
    }

    function QtrIsInternalScanRunning (  ) 
    {
        //QtrLogMessage ("INFO","Check if internal scan running");
	    var running = false;

        jQuery.ajax({
            data: {
                action: 'scanner-is_internal_scan_running',
            }, 

            success: function(r) {
                console.log(r);
                if( r == "yes" ){
                    //QtrLogMessage ("INFO","Operation succeeded. Internal scan is running");
                    QtrShowProgressBar();
                }else{
                    //QtrLogMessage ("INFO","Operation succeeded. Internal scan is not running");
                    QtrHideProgressBar();
                }					
            }//end of success function
        });
        return running;
    };


    function QtrReloadExecutionStatus( repeat ){

        QtrReloadExecutionLog( );

        QtrReloadExecutionStats();

        if( repeat ){
            /*
             * set periodic timer
             */
            setTimeout( QtrReloadExecutionStatus, 20000, repeat );
        }
        
    }


    function QtrCleanExecutionLog( )
    {
        console.log("QtrCleanExecutionLog called");
        document.getElementById("log").value = "";
        last_log_line = 0;

        jQuery.ajax({
            data: {
                action: 'scanner-clean_log',
            }, 
            success: function(r) {
                //console.log(r);
            }
        });
    }


    function QtrReloadExecutionLog ( )
    {
        console.log("QtrReloadExecutionLog");

        jQuery.ajax({
            data: {
                action: 'scanner-get_log_lines',
                start_line: last_log_line,
            }, 
            success: function(r) {
                //console.log(r);
                //alert(r);
                //return;
                //
                var log_lines = jQuery.parseJSON(r);
                if( !Array.isArray(log_lines) ){
                    console.log ("Invalid input: " + log_lines );
                    return;
                }

                if( log_lines )
                {
                    /*
                    for( var i = 0 ; i < log_lines.length ; i++ )
                    {
                        var index       = 0;    
                        var severity    = null;
                        var message     = null;

                        if( log_lines[i].length >=1 ){
                            index = log_lines[i][0];
                        }
                        if( log_lines[i].length >= 2 ){
                            severity = log_lines[i][1];
                        }
                        if( log_lines[i].length >= 3 ){
                            message = log_lines[i][2];
                        }

                        //alert(message);
                        if( index > last_log_line )
                        {
                            QtrLogMessage ( severity,message );
                            last_log_line = index; 
                        }
                    }*/
                    QtrLogMessages( log_lines );
                }
            }//end of success function
        });
    }

    function QtrReloadExecutionStats ( )
    {
        jQuery.ajax({
            data: {
                action: 'scanner-get_stats',
            }, 
            success: function(r) {
                var counters = jQuery.parseJSON(r);
                QtrUpdateExecutionStats( counters );
            }//end of success function
        });

    }


    function QtrReloadDetectedThreatsReport ( )
    {
        jQuery.ajax({
            data: {
                action: 'scanner-get_detected_threats',
            }, 
            success: function(r) 
            {
                console.log(r);

                var threats = jQuery.parseJSON(r);

                if( Array.isArray(threats) )
                {
                    QtrCleanDetectedThreatsReport();
                    threats_to_show = 100;

                    if( threats_to_show > threats.length ){
                        threats_to_show = threats.length;
                    }

                    if( threats_to_show != 0 )
                    {
                        for(var i = 0; i < threats_to_show; i++ )
                        {
                            QtrAddToDetectedThreatsReport( threats[i] );
                        }
                    }
                    else
                    {
                        console.log("Threats arry is clean");
                        QtrShowEmptyThreatsReport();
                    }
                    //
                }
                else
                {
                    console.log("Retrieved invalid output: " + r);
                }
            }//end of success function
        });
    }



    function QtrShowEmptyThreatsReport ( )
    {
        document.getElementById('detected_threats_report').style.display    = 'none';
        document.getElementById('detected_threats_report').style.display    = 'block';
        document.getElementById("detected_threats_report").innerHTML        = "<center><p>No entries have been found</p></center>";
    }


    function QtrCleanDetectedThreatsReport ( )
    {
        document.getElementById("detected_threats_report").innerHTML = "";
    }


    function QtrAddToDetectedThreatsReport( report )
    {
        var alert_type = "alert alert-info";
        var severity   = report["SEVERITY"].toLowerCase();

        if( severity.indexOf("malicious") >= 0 ){
            alert_type = "alert alert-danger";
        }else if( severity.indexOf("susp") >= 0 ){
            alert_type = "alert alert-warning";
        }

        var threat      = report["THREAT"].substr(0,20); 
        var filename    = QtrStripFilePath(report["FILE"],60);
        var file_md5    = report["FILE_MD5"];
        var threat_sig  = report["THREAT_SIG"];

        document.getElementById("detected_threats_report").innerHTML += 
            "</br>\n" +
            "<div class='" + alert_type + "'>\n"+
                "<table class='table'>\n" +
                    "<tr><td>Severity: </td><td> " + report["SEVERITY"] + "</td></tr>\n" +
                    "<tr><td>File: </td><td> " + filename + "</td></tr>\n" +
                    "<tr><td>File signature: </td><td> " + report["FILE_MD5"] + "</td></tr>\n" +
                    "<tr><td>Threat signature: </td><td> " + report["THREAT_SIG"] + "</td></tr>\n" +
                    "<tr><td>Threat: </td><td> " + threat  + "</td></tr>\n" +
                    "<tr><td>Details: </td><td> " + report["DETAILS"] + "</td></tr>\n" +
                "</table>\n" + 
                "<div class='btn-group btn-group-xs pull-left'>\n" + 
                    "<button type='button' class='button-primary btn-sm' onclick='QtrIgnoreThreat(\"" + file_md5 + "\",\"" + threat_sig + "\")'>Ignore Threat</button>\n" +
                    "<button type='button' class='button-primary btn-sm' onclick='QtrWhitelistFile(\"" + file_md5 + "\")'>WhiteList File</button>\n" +
                    "<button type='button' class='button-primary btn-sm' onclick='QtrWhitelistThreat(\"" + file_md5 + "\",\"" + threat_sig + "\")'>Not a Threat</button>\n" +
                "</div>\n";
           "</div>\n";
    }

    /*

                <button type="button" class="button-primary btn-sm dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" id="stop-internal-scanner">
                    Stop Scanner
                </button>
    */

    function QtrAddToIgnoredThreatsReport( report )
    {
        var alert_type = "alert alert-info";
        var severity   = report["SEVERITY"].toLowerCase();

        if( severity.indexOf("malicious") >= 0 ){
            alert_type = "alert alert-danger";
        }else if( severity.indexOf("susp") >= 0 ){
            alert_type = "alert alert-warning";
        }

        var threat      = report["THREAT"].substr(0,20); 
        var filename    = QtrStripFilePath(report["FILE"],60);
        var file_md5    = report["FILE_MD5"];
        var threat_sig  = report["THREAT_SIG"];

        document.getElementById("ignored_threats_report").innerHTML += 
            "</br>\n" +
            "<div class='" + alert_type + "'>\n"+
                "<table class='table'>\n" +
                    "<tr><td>Severity: </td><td> " + report["SEVERITY"] + "</td></tr>\n" +
                    "<tr><td>File: </td><td> " + filename + "</td></tr>\n" +
                    "<tr><td>File signature: </td><td> " + report["FILE_MD5"] + "</td></tr>\n" +
                    "<tr><td>Threat signature: </td><td> " + report["THREAT_SIG"] + "</td></tr>\n" +
                    "<tr><td>Threat: </td><td> " + threat  + "</td></tr>\n" +
                    "<tr><td>Details: </td><td> " + report["DETAILS"] + "</td></tr>\n" +
                "</table>\n" + 
                "<div class='btn-group btn-group-xs'>\n" + 
                "<button type='button' class='button-primary btn-sm' onclick='QtrRemoveFromIgnoreList(\"" + file_md5 + "\",\"" + threat_sig + "\")'>Remove from Ignore List</button>\n" +
                "</div>\n";
           "</div>\n";
    }



    function QtrReloadIgnoredThreatsReport ( )
    {
        console.log("QtrReloadIgnoredThreatsReport");

        QtrShowEmptyIgnoreList();

        jQuery.ajax({
            data: {
                action: 'scanner-get_ignored_threats',
            }, 
            success: function(r) {
                //console.log(r);
                var threats = jQuery.parseJSON(r);

                if( Array.isArray(threats) ){
                    QtrCleanIgnoreThreatsReport();
                    threats_to_show = 100;

                    if( threats_to_show > threats.length ){
                        threats_to_show = threats.length;
                    }

                    if( threats_to_show != 0 )
                    {
                        for(var i = 0; i < threats_to_show; i++ )
                        {
                            QtrAddToIgnoredThreatsReport( threats[i] );
                        }
                    }
                    else
                    {
                        console.log("Ignored list is clean");
                        QtrShowEmptyIgnoreList();
                    }
                }else{
                    console.log("Retrieved invalid output: " + r);
                }
            }//end of success function
        });
    }


    function QtrWhitelistFile( file_sig )
    {
         jQuery.ajax({
            data: {
                action: 'scanner-whitelist_file',
                FILE_MD5: file_sig,
            }, 
            success: function(r) {
                console.log(r);
                console.log("QtrWhitelistFile operation succeeded");
                QtrReloadDetectedThreatsReport ( );
            }//end of success function
        });
       
    }

    function QtrWhitelistThreat(file,threat)
    {
        jQuery.ajax({
            data: {
                action: 'scanner-whitelist_threat',
                FILE_MD5: file,
                THREAT_SIG: threat,
            }, 
            success: function(r) {
                console.log(r);
                console.log("QtrWhitelistThreat: operation succeeded" );
                QtrReloadDetectedThreatsReport ( );
            }//end of success function
        });
    }



    function QtrShowEmptyIgnoreList ( )
    {
        /*
         * First two lines used to refresh element if it is shown
         */
        document.getElementById('ignored_threats_report').style.display = 'none';
        document.getElementById('ignored_threats_report').style.display = 'block';
        document.getElementById("ignored_threats_report").innerHTML = "<center><p>No entries have been found</p></center>";
    }


    function QtrCleanIgnoreThreatsReport ( )
    {
        document.getElementById("ignored_threats_report").innerHTML = "";
    }


    function QtrIgnoreThreat(file,threat)
    {
        jQuery.ajax({
            data: {
                action: 'scanner-ignore_threat',
                FILE_MD5: file,
                THREAT_SIG: threat,
            }, 
            success: function(r) {
                /* 
                 * refresh content of the tab
                 */
                QtrReloadDetectedThreatsReport ( );
            }//end of success function
        });
    }


    function QtrRemoveFromIgnoreList(file,threat)
    {
        jQuery.ajax({
            data: {
                action: 'scanner-unignore_threat',
                FILE_MD5: file,
                THREAT_SIG: threat,
            }, 
            success: function(r) {
                /* 
                 * refresh content of the tab
                 */
                QtrReloadIgnoredThreatsReport();
            }//end of success function
        });
    }


    function QtrRunInternalScan ( level ) 
    {
        QtrLogMessage ("INFO","Submitting internal scan request");

        jQuery.ajax({
            data: {
                action: 'scanner-run_internal_scan',
            }, 


            timeout: 3000, // sets timeout to 3 seconds

            error: function(jqXHR, textStatus){
                QtrLogMessage ("INFO","Internal scan request submitted");
            },
            success: function(r) {
                QtrLogMessage ("INFO","Operation succeeded. Internal scan started");
            }//end of success function
        });

        QtrReloadExecutionStatus( 0 );
    };


    function QtrLogMessages( messages )
    {
        var body = "";
        for( var i =0; i < messages.length; i++ )
        {
            /* index 0 is line number */
            var line = messages[i][1] + "\t" + messages[i][2] + "\n";
            if( log_lines.length >= max_log_lines ){
                /*
                 * removes first line from front
                 */ 
                log_lines.shift();
            }
            log_lines.push( line );
            body += line;
        }

        document.getElementById("log").value = body;
        document.getElementById("log").scrollTop = document.getElementById("log").scrollHeight;
    }


    function QtrLogMessage(severity,message)
    {
        if( !severity || !message ){
            return ;
        }

        var log_line = severity + "\t" + message;

        if( log_lines.length >= max_log_lines ){
            /*
             * removes first line from front
             */ 
            log_lines.shift();
        }

        log_lines.push( log_line );

        var body = "";
        for( var i = 0; i < log_lines.length; i++ ){
            body += log_lines[i] + "\n";
        }

        document.getElementById("log").value = body;
        document.getElementById("log").scrollTop = document.getElementById("log").scrollHeight;
    }


    function QtrUpdateExecutionStats( counters )
    {
        var start = new Date( counters["START_TIME"] * 1000 );

        document.getElementById("scan_start_time").innerHTML                = start.toTimeString();
        document.getElementById("total_scanned_files").innerHTML            = counters["TOTAL"];
        document.getElementById("scanned_clean_files").innerHTML            = counters["CLEAN"];
        document.getElementById("scanned_pos_suspicious_files").innerHTML   = counters["POT_SUSPICIOUS"];
        document.getElementById("scanned_suspicious_files").innerHTML       = counters["SUSPICIOUS"];
        document.getElementById("scanned_malicious_files").innerHTML        = counters["MALICIOUS"];
    }


    /**
     * @brief       cut off too long parts of path to shorter form with dots
     * @param[in]   path    - path to convert
     * @param[in]   maxlen  - maximal permitted length
     * @return      converted path
     */
    function QtrStripFilePath( path,maxlen )
    {
        if( path.length <= maxlen ){
            return path;
        }

        name_pos        = path.lastIndexOf("/");
        name            = path.substring( name_pos );
        path_part_end   = maxlen - name.length - 5;
        path_part       = path.substring(0,path_part_end) + "/..." + name;
        return path_part;
    }
</script>

